<template>
  <q-card
    :square="!isDesktopPlatform"
    class="column no-wrap col"
  >
    <q-scroll-area class="full-width full-height q-mt-md">
      <q-list>
        <template
          v-for="(npkRecommendation, npkRecommendationIndex) in npkRecommendations"
          :key="'plot-' + npkRecommendation.plot_id + '-recommendations-item'"
        >
          <q-item
            class="flex-center q-py-none"
          >
            <q-item-label
              class="text-subtitle1 text-secondary"
            >
              <q-icon
                size="sm"
                name="la la-draw-polygon"
              />
              <span class="">
                {{ npkRecommendation.plot_name || npkRecommendation.plot_id }}
              </span>
            </q-item-label>
          </q-item>
          <!-- Plant species and yield-->
          <q-item-label
            header
            class="q-pt-none q-pb-sm text-subtitle2"
          >
            <div class="row items-center q-col-gutter-x-sm">
              <div class="col-auto">
                <q-icon
                  size="sm"
                  name="la la-pagelines"
                />
              </div>
              <span
                class="col"
              >
                {{ npkRecommendation.plant_species_name }}
              </span>
              <span class="col-auto q-pl-md">
                {{ npkRecommendation.crop_yield }}
                <span>{{ unitOfMeasuresSymbol[npkRecommendation.crop_yield_unit_of_measure_id] }} </span>
              </span>
            </div>
          </q-item-label>
          <q-banner
            class="bg-grey-2"
            :class="npkRecommendationIndex < npkRecommendations.length - 1 ? 'q-mb-lg': ''"
          >
            <div class="row q-mt-sm">
              <div
                v-for="elementRecommendation in npkRecommendation.element_recommendations"
                :key="'nutrient-provided-by-manure-element-'+elementRecommendation.chemical_element_id"
                class="column text-center"
                :class="npkRecommendation.element_recommendations.length < 3 ? 'col': 'col-4'"
              >
                <span
                  class="q-mb-sm text-uppercase"
                  :class="`text-${elementRecommendation.chemical_element_id.toLowerCase()}`"
                >
                  {{ elementRecommendation.chemical_element_id }}
                </span>
                <span
                  class="text-body1 text-bold"
                  :class="`text-${elementRecommendation.chemical_element_id.toLowerCase()}`"
                >{{ Math.round(elementRecommendation.quantity, 1) }}</span>
                <span class="text-grey">{{ unitOfMeasuresSymbol[npkRecommendation.crop_yield_unit_of_measure_id] }}</span>
              </div>
            </div>
          </q-banner>
        </template>
      </q-list>
    </q-scroll-area>

    <!-- buttons -->
    <slot name="action-buttons" />

    <q-card-section
      v-if="displayActionButtons"
      class="q-mt-auto"
    >
      <q-card-actions
        vertical
        align="stretch"
        class="q-pa-none"
      >
        <q-btn
          color="primary"
          text-color="white"
          :loading="saving"
          @click="onClickSavePlan"
        >
          {{ savePlanButtonLabel }}
        </q-btn>
        <q-btn
          flat
          color="primary"
          @click="onClickPrevious"
        >
          <translate>Previous</translate>
        </q-btn>
        <q-btn
          flat
          color="primary"
          @click="$router.push({name: 'fertilizationPlans'})"
        >
          <translate>Back to all my plans</translate>
        </q-btn>
      </q-card-actions>
    </q-card-section>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'

export default {
  name: 'ArcResultsCard',
  mixins: [PlatformMixin, FertilizationPlanMixin],
  props: {
    fertilizationPlanParameters: {
      type: Object,
      required: true
    },
    fertilizationPlanResults: {
      type: Object,
      required: false,
      default: null
    },
    fertilizationPlanTarget: {
      type: Object,
      required: false,
      default: null
    },
    displayActionButtons: {
      type: Boolean,
      default: true
    }
  },
  computed: {
    npkRecommendations () {
      return this.fertilizationPlanResults != null
        ? this.fertilizationPlanResults.npk_recommendations
        : this.npkRecommendationsFromFertilizationPlanParameters
    },
    npkRecommendationsFromFertilizationPlanParameters () {
      return Object.keys(this.fertilizationPlanParameters.results).map(plotId => {
        return {
          rotation_order: 1,
          plot_id: Number(plotId),
          plot_name: this.fertilizationPlanTarget?.id != null && Number(this.fertilizationPlanTarget.id) === Number(plotId) ? this.fertilizationPlanTarget.name : null,
          plant_species_id: this.fertilizationPlanParameters.results[plotId].plant_species.id,
          plant_species_name: this.fertilizationPlanParameters.results[plotId].plant_species.name,
          crop_yield: this.fertilizationPlanParameters.results[plotId].yield_target,
          crop_yield_unit_of_measure_id: this.unitOfMeasures.KILOGRAM_PER_HECTARE,
          element_recommendations: this.fertilizationPlanParameters.results[plotId].recommendations.map(recommendation => {
            return {
              chemical_element_id: this.chemicalElementsIds[recommendation.chemical_element_id],
              quantity: Number(recommendation.quantity),
              unit_of_measure_id: this.unitOfMeasures.KILOGRAM_PER_HECTARE
            }
          }),
          advices: [],
          warnings: []
        }
      })
    }
  },
  methods: {
    onClickPrevious () {
      this.$router.back()
    },
    onClickSavePlan () {
      const result = { npk_recommendations: this.npkRecommendations }
      this.savePlan(result)
    }
  }
}
</script>
